=== debian/changelog ===
eliom (3.0.3-4build2) trusty; urgency=medium

  * Rebuild for new OCaml ABIs.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 04 Feb 2014 10:35:39 +0000

eliom (3.0.3-4build1) trusty; urgency=medium

  * Rebuild for new OCaml ABIs.

 -- Colin Watson <cjwatson@ubuntu.com>  Thu, 09 Jan 2014 14:14:24 +0000

eliom (3.0.3-4) unstable; urgency=low

  * Upload to unstable

 -- Stéphane Glondu <glondu@debian.org>  Sat, 07 Dec 2013 13:56:26 +0100

eliom (3.0.3-3) experimental; urgency=low

  * Build-depend on ocaml-findlib >= 1.4 to pick up new native
    architectures

 -- Stéphane Glondu <glondu@debian.org>  Fri, 22 Nov 2013 19:52:51 +0100

eliom (3.0.3-2) experimental; urgency=low

  * Fix eliom-server doc-base files
  * Compile with OCaml >= 4.01
  * Update Vcs-*

 -- Stéphane Glondu <glondu@debian.org>  Mon, 11 Nov 2013 07:51:01 +0100

eliom (3.0.3-1) unstable; urgency=low

  * New upstream release
  * Update debian/watch
  * Bump Standards-Version to 3.9.4
  * Upload to unstable

 -- Stéphane Glondu <glondu@debian.org>  Fri, 10 May 2013 17:07:21 +0200

eliom (3.0.2-1) experimental; urgency=low

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Wed, 12 Dec 2012 07:54:38 +0100

eliom (3.0.1-1) experimental; urgency=low

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Mon, 10 Dec 2012 21:36:30 +0100

eliom (3.0.0-2) experimental; urgency=low

  * Put binaries and templates in a separate (new) binary package with
    more precise dependencies

 -- Stéphane Glondu <glondu@debian.org>  Mon, 10 Dec 2012 12:34:58 +0100

eliom (3.0.0-1) experimental; urgency=low

  * New upstream release
    - OCamlDuce support has been dropped
    - update minimal versions of the Ocsigen stack in Build-Depends

 -- Stéphane Glondu <glondu@debian.org>  Sat, 08 Dec 2012 21:36:15 +0100
